import 'reflect-metadata';
import { injectable, inject, ContainerModule, decorate } from 'inversify';
import EventEmitter from 'eventemitter3';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();

  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
        result;

    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];

  if (!it) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;

      var F = function () {};

      return {
        s: F,
        n: function () {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function (e) {
          throw e;
        },
        f: F
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var normalCompletion = true,
      didErr = false,
      err;
  return {
    s: function () {
      it = it.call(o);
    },
    n: function () {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function (e) {
      didErr = true;
      err = e;
    },
    f: function () {
      try {
        if (!normalCompletion && it.return != null) it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __metadata(metadataKey, metadataValue) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
}

var ObjectPool = /*#__PURE__*/function () {
  function ObjectPool() {
    _classCallCheck(this, ObjectPool);

    this.count = 0;
    this.freeList = [];
    this.objectFactory = void 0;
  }

  _createClass(ObjectPool, [{
    key: "init",
    value: function init(T, initialSize) {
      this.objectFactory = T;

      if (typeof initialSize !== 'undefined') {
        this.expand(initialSize);
      }
    }
  }, {
    key: "acquire",
    value: function acquire() {
      if (this.freeList.length <= 0) {
        this.expand(Math.round(this.count * 0.2) + 1);
      }

      return this.freeList.pop();
    }
  }, {
    key: "release",
    value: function release(item) {
      item.reset();
      this.freeList.push(item);
    }
  }, {
    key: "expand",
    value: function expand(count) {
      for (var n = 0; n < count; n++) {
        var clone = this.objectFactory();
        this.freeList.push(clone);
      }

      this.count += count;
    }
  }]);

  return ObjectPool;
}();

ObjectPool = __decorate([injectable()], ObjectPool);

var Component_1;
var counter = 0;

var Component = Component_1 = /*#__PURE__*/function () {
  function Component() {
    _classCallCheck(this, Component);

    this.pid = counter++;
  }

  _createClass(Component, [{
    key: "getId",
    value: function getId() {
      return this.pid;
    }
  }, {
    key: "copy",
    value: function copy(props) {
      Object.assign(this, props);
      return this;
    }
  }, {
    key: "clone",
    value: function clone() {
      return new Component_1().copy(this);
    }
  }, {
    key: "reset",
    value: function reset() {//
    }
  }, {
    key: "destroy",
    value: function destroy() {//
    }
  }]);

  return Component;
}();

Component = Component_1 = __decorate([injectable()], Component);

var IDENTIFIER = {
  EventEmitter: 'EventEmitter',
  ComponentRegistry: 'ComponentRegistry',
  ComponentManager: 'ComponentManager',
  ComponentPoolFactory: 'ComponentPoolFactory',
  ComponentPool: 'ComponentPool',
  ObjectFactory: 'ObjectFactory',
  EntityPoolFactory: 'EntityPoolFactory',
  System: 'System',
  SystemRegistry: 'SystemRegistry'
};

var ENTITY_EVENT = {
  Created: 'Created'
};
var COMPONENT_EVENT = {
  Added: 'Added',
  Remove: 'Remove'
};

var EntityManager = /*#__PURE__*/function (_EventEmitter) {
  _inherits(EntityManager, _EventEmitter);

  var _super = _createSuper(EntityManager);

  function EntityManager() {
    var _this;

    _classCallCheck(this, EntityManager);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.componentPoolFactory = void 0;
    _this.entities = [];
    _this.entitiesByNames = {};
    _this.matcherCache = {};
    return _this;
  }

  _createClass(EntityManager, [{
    key: "getEntityByName",
    value: function getEntityByName(name) {
      return this.entitiesByNames[name];
    }
  }, {
    key: "getAllEntities",
    value: function getAllEntities() {
      return this.entities;
    }
  }, {
    key: "queryByMatcher",
    value: function queryByMatcher(matcher) {
      var hash = matcher.hash();

      if (!this.matcherCache[hash]) {
        this.matcherCache[hash] = this.entities.filter(function (entity) {
          return matcher.matches(entity);
        });
      }

      return this.matcherCache[hash];
    }
  }, {
    key: "createEntity",
    value: function createEntity(entity) {
      var name = entity.getName();

      if (name) {
        if (this.entitiesByNames[name]) {
          throw new Error("Entity name '".concat(name, "' already exist"));
        } else {
          this.entitiesByNames[name] = entity;
        }
      }

      this.entities.push(entity);
      this.emit(ENTITY_EVENT.Created, entity);
      return entity;
    }
  }, {
    key: "destroyEntity",
    value: function destroyEntity(entity) {
      if (entity.getName()) {
        delete this.entitiesByNames[entity.getName()];
      }

      var index = this.entities.indexOf(entity);

      if (index > -1) {
        this.entities.splice(index, 1);
      }

      this.matcherCache = {};
    }
  }, {
    key: "addComponentToEntity",
    value: function addComponentToEntity(entity, clazz, values) {
      var tag = clazz.tag;
      var components = entity.getComponents();
      var component = components[tag];

      if (component) {
        if (!entity.cast(component, clazz)) {
          throw new Error("There are multiple classes with the same tag or name \"".concat(tag, "\".\nAdd a different property \"tag\" to one of them."));
        }

        delete components[tag];
      }

      component = this.componentPoolFactory(clazz).acquire();

      if (values) {
        component.copy(values);
      }

      components[tag] = component;
      this.emit(COMPONENT_EVENT.Added, entity, component);
      this.matcherCache = {};
      return component;
    }
  }, {
    key: "removeComponentFromEntity",
    value: function removeComponentFromEntity(entity, clazz) {
      var immediately = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

      if (!entity.hasComponent(clazz)) {
        return;
      }

      this.emit(COMPONENT_EVENT.Remove, entity, clazz);

      if (immediately) {
        this.removeComponentFromEntitySync(entity, clazz);
      }

      this.matcherCache = {};
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.entities = [];
      this.entitiesByNames = {};
    }
  }, {
    key: "removeComponentFromEntitySync",
    value: function removeComponentFromEntitySync(entity, clazz) {
      // Remove T listing on entity and property ref, then free the component.
      // entity._ComponentTypes.splice(index, 1);
      var component = entity.getComponent(clazz);
      var components = entity.getComponents();
      delete components[clazz.tag];
      component.destroy(); // this.world.componentsManager.componentRemovedFromEntity(Component);
    }
  }]);

  return EntityManager;
}(EventEmitter);

__decorate([inject(IDENTIFIER.ComponentPoolFactory), __metadata("design:type", Function)], EntityManager.prototype, "componentPoolFactory", void 0);

EntityManager = __decorate([injectable()], EntityManager);

var counter$1 = 0;
/**
 * A bag of components
 * @see https://github.com/mzaks/EntitasCookBook/blob/master/chapters/1_ingredients/102_entity.md
 */

var Entity = /*#__PURE__*/function () {
  function Entity() {
    _classCallCheck(this, Entity);

    this.id = counter$1++;
    this.name = void 0;
    this.components = {};
    this.entityManager = void 0;
  }

  _createClass(Entity, [{
    key: "getId",
    value: function getId() {
      return this.id;
    }
  }, {
    key: "getComponents",
    value: function getComponents() {
      return this.components;
    }
  }, {
    key: "setName",
    value: function setName(name) {
      this.name = name;
    }
  }, {
    key: "getName",
    value: function getName() {
      return this.name || "".concat(this.id);
    }
  }, {
    key: "getComponent",
    value: function getComponent(clazz) {
      return this.components[clazz.tag];
    }
  }, {
    key: "hasComponent",
    value: function hasComponent(clazz) {
      return !!~Object.keys(this.components).indexOf(clazz.tag);
    }
  }, {
    key: "hasAllComponents",
    value: function hasAllComponents(clazzes) {
      var _this = this;

      return clazzes.every(function (clazz) {
        return _this.hasComponent(clazz);
      });
    }
  }, {
    key: "hasAnyComponents",
    value: function hasAnyComponents(clazzes) {
      var _this2 = this;

      return clazzes.some(function (clazz) {
        return _this2.hasComponent(clazz);
      });
    }
  }, {
    key: "addComponent",
    value: function addComponent(clazz, values) {
      return this.entityManager.addComponentToEntity(this, clazz, values);
    }
  }, {
    key: "removeComponent",
    value: function removeComponent(clazz) {
      var forceImmediate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      this.entityManager.removeComponentFromEntity(this, clazz, forceImmediate);
      return this;
    } // removeAllComponents() {
    //   return this;
    // }

  }, {
    key: "reset",
    value: function reset() {//
    }
  }, {
    key: "destroy",
    value: function destroy() {
      // TODO: remove components first
      // for (const name in this.components) {
      //   this.entityManager.removeComponentFromEntity(this, this.components[name]);
      // }
      this.entityManager.destroyEntity(this);
    }
  }, {
    key: "cast",
    value: function cast(component, componentClass) {
      return !!(component && component instanceof componentClass);
    }
  }]);

  return Entity;
}();

__decorate([inject(EntityManager), __metadata("design:type", EntityManager)], Entity.prototype, "entityManager", void 0);

Entity = __decorate([injectable()], Entity);

var ComponentManager = /*#__PURE__*/function () {
  function ComponentManager() {
    _classCallCheck(this, ComponentManager);

    this.registry = void 0;
  }

  _createClass(ComponentManager, [{
    key: "registerComponent",
    value: function registerComponent(clazz) {
      this.registry(clazz);
    }
  }]);

  return ComponentManager;
}();

__decorate([inject(IDENTIFIER.ComponentRegistry), __metadata("design:type", Function)], ComponentManager.prototype, "registry", void 0);

ComponentManager = __decorate([injectable()], ComponentManager);

var SystemManager = /*#__PURE__*/function () {
  function SystemManager() {
    _classCallCheck(this, SystemManager);

    this.registry = void 0;
    this.entityManager = void 0;
    this.systems = [];
  }

  _createClass(SystemManager, [{
    key: "registerSystem",
    value: function registerSystem(clazz) {
      if (!this.registry.has(clazz)) {
        this.registry.register(clazz);
        var system = this.registry.get(clazz);
        var systemCtor = system.constructor;

        if (system.initialize) {
          // TODO: support async init @see https://github.com/ecsyjs/ecsy/issues/20
          system.initialize();
        } else {
          system.initialized = true;
        }

        this.entityManager.on(COMPONENT_EVENT.Added, function (entity) {
          if (system.onEntityAdded && systemCtor.trigger && systemCtor.trigger.matches(entity)) {
            system.onEntityAdded(entity);
          }
        });
        this.entityManager.on(COMPONENT_EVENT.Remove, function (entity) {
          if (system.onEntityRemoved && systemCtor.trigger && systemCtor.trigger.matches(entity)) {
            system.onEntityRemoved(entity);
          }
        });
        this.systems.push(system);
        this.systems.sort(function (a, b) {
          return (a.constructor.priority || 0) - (b.constructor.priority || 0);
        });
      }
    }
  }, {
    key: "execute",
    value: function execute(delta, millis) {
      var _iterator = _createForOfIteratorHelper(this.systems),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var system = _step.value;

          if (system.initialized && system.execute) {
            // const t1 = performance.now();
            system.execute(this.getEntities(system), delta, millis); // console.log((system.constructor as SystemConstructor<System>).tag, performance.now() - t1);
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
  }, {
    key: "destroy",
    value: function destroy() {
      var _this = this;

      this.systems.forEach(function (system) {
        if (system.initialized && system.tearDown) {
          system.tearDown(_this.getEntities(system));
        }
      });
    }
  }, {
    key: "getEntities",
    value: function getEntities(system) {
      var systemCtor = system.constructor;
      return systemCtor.trigger ? this.entityManager.queryByMatcher(systemCtor.trigger) : this.entityManager.getAllEntities();
    }
  }]);

  return SystemManager;
}();

__decorate([inject(IDENTIFIER.SystemRegistry), __metadata("design:type", Object)], SystemManager.prototype, "registry", void 0);

__decorate([inject(EntityManager), __metadata("design:type", EntityManager)], SystemManager.prototype, "entityManager", void 0);

SystemManager = __decorate([injectable()], SystemManager);

/**
 * the context of ECS
 * @see https://github.com/sschmid/Entitas-CSharp/blob/master/Entitas/Entitas/Context/IContext.cs
 * @example
 * ```
 * // register components
 * world
    .registerComponent(C1)
    .registerComponent(C2)
    .registerComponent(C3);
  
  // register systems
 * ```
 */

var World = /*#__PURE__*/function () {
  function World() {
    _classCallCheck(this, World);

    this.entityPoolFactory = void 0;
    this.entityManager = void 0;
    this.componentManager = void 0;
    this.systemManager = void 0;
    this.lastMillis = new Date().getTime();
    this.enabled = true;
  }

  _createClass(World, [{
    key: "createEntity",
    value: function createEntity() {
      var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
      var entity = this.entityPoolFactory().acquire();
      entity.setName(name);
      return this.entityManager.createEntity(entity);
    }
  }, {
    key: "getEntityByName",
    value: function getEntityByName(name) {
      return this.entityManager.getEntityByName(name);
    }
  }, {
    key: "registerComponent",
    value: function registerComponent(clazz) {
      this.componentManager.registerComponent(clazz);
      return this;
    }
  }, {
    key: "registerSystem",
    value: function registerSystem(clazz) {
      this.systemManager.registerSystem(clazz);
      return this;
    }
  }, {
    key: "execute",
    value: function execute(delta, millis) {
      if (!delta) {
        millis = new Date().getTime();
        delta = millis - this.lastMillis;
        this.lastMillis = millis;
      }

      if (this.enabled) {
        this.systemManager.execute(delta, millis);
      }
    }
  }, {
    key: "stop",
    value: function stop() {
      this.enabled = false;
    }
  }, {
    key: "resume",
    value: function resume() {
      this.enabled = true;
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.systemManager.destroy();
      this.entityManager.destroy(); // this.componentManager.destroy();
    }
  }]);

  return World;
}();

__decorate([inject(IDENTIFIER.EntityPoolFactory), __metadata("design:type", Function)], World.prototype, "entityPoolFactory", void 0);

__decorate([inject(EntityManager), __metadata("design:type", EntityManager)], World.prototype, "entityManager", void 0);

__decorate([inject(ComponentManager), __metadata("design:type", ComponentManager)], World.prototype, "componentManager", void 0);

__decorate([inject(SystemManager), __metadata("design:type", SystemManager)], World.prototype, "systemManager", void 0);

World = __decorate([injectable()], World);

var System = Symbol('System');

/**
 * Query language of ECS
 * @see https://github.com/mzaks/EntitasCookBook/blob/master/chapters/1_ingredients/104_group.md#matcher
 * @example
 * ```
 * matcher.allOf(Position, Velocity).noneOf(NotMovable)
 * ```
 */
var Matcher = /*#__PURE__*/function () {
  function Matcher() {
    _classCallCheck(this, Matcher);

    this.allOfComponentCtors = [];
    this.anyOfComponentCtors = [];
    this.noneOfComponentCtors = [];
  }

  _createClass(Matcher, [{
    key: "allOf",
    value: function allOf() {
      for (var _len = arguments.length, clazzes = new Array(_len), _key = 0; _key < _len; _key++) {
        clazzes[_key] = arguments[_key];
      }

      this.allOfComponentCtors = clazzes;
      return this;
    }
  }, {
    key: "anyOf",
    value: function anyOf() {
      for (var _len2 = arguments.length, clazzes = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        clazzes[_key2] = arguments[_key2];
      }

      this.anyOfComponentCtors = clazzes;
      return this;
    }
  }, {
    key: "noneOf",
    value: function noneOf() {
      for (var _len3 = arguments.length, clazzes = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        clazzes[_key3] = arguments[_key3];
      }

      this.noneOfComponentCtors = clazzes;
      return this;
    }
  }, {
    key: "matches",
    value: function matches(entity) {
      var matchesAllOf = !this.allOfComponentCtors.length ? true : entity.hasAllComponents(this.allOfComponentCtors);
      var matchesAnyOf = !this.anyOfComponentCtors.length ? true : entity.hasAnyComponents(this.anyOfComponentCtors);
      var matchesNoneOf = !this.noneOfComponentCtors.length ? true : !entity.hasAnyComponents(this.noneOfComponentCtors);
      return matchesAllOf && matchesAnyOf && matchesNoneOf;
    }
  }, {
    key: "hash",
    value: function hash() {
      return [].concat(_toConsumableArray(this.allOfComponentCtors), _toConsumableArray(this.anyOfComponentCtors), _toConsumableArray(this.noneOfComponentCtors)).map(function (c) {
        return c.tag;
      }).join();
    }
  }]);

  return Matcher;
}();

var isEventEmitterBound = false;
var containerModule = new ContainerModule(function (bind) {
  if (!isEventEmitterBound) {
    decorate(injectable(), EventEmitter);
    bind(IDENTIFIER.EventEmitter).to(EventEmitter);
    isEventEmitterBound = true;
  }

  bind(IDENTIFIER.ComponentRegistry).toFactory(function (context) {
    return function (clazz) {
      if (!context.container.isBound(clazz)) {
        context.container.bind(clazz).toSelf();
      }
    };
  });
  bind(IDENTIFIER.SystemRegistry).toDynamicValue(function (context) {
    return {
      register: function register(clazz) {
        if (!context.container.isBoundTagged(System, clazz.tag, clazz)) {
          context.container.bind(System).to(clazz).inSingletonScope().whenTargetNamed(clazz.tag);
        }
      },
      get: function get(clazz) {
        return context.container.getNamed(System, clazz.tag);
      },
      has: function has(clazz) {
        return context.container.isBoundNamed(System, clazz.tag);
      }
    };
  });
  bind(IDENTIFIER.ComponentPoolFactory).toFactory(function (context) {
    var factoryRegistry = {};
    return function (clazz) {
      var componentPool = factoryRegistry[clazz.tag];

      if (!componentPool) {
        componentPool = context.container.get(ObjectPool);
        componentPool.init(function () {
          var isBound = context.container.isBound(clazz);

          if (!isBound) {
            throw new Error("Component \"".concat(clazz.tag, "\" is not registered, please call registerComponent() first."));
          }

          var component = context.container.get(clazz);
          return component;
        }, 10);
        factoryRegistry[clazz.tag] = componentPool;
      }

      return componentPool;
    };
  });
  bind(IDENTIFIER.EntityPoolFactory).toFactory(function (context) {
    var entityPool;
    return function () {
      if (!entityPool) {
        entityPool = context.container.get(ObjectPool);
        entityPool.init(function () {
          return context.container.get(Entity);
        }, 10);
      }

      return entityPool;
    };
  });
  bind(EntityManager).toSelf().inSingletonScope();
  bind(ComponentManager).toSelf().inSingletonScope();
  bind(SystemManager).toSelf().inSingletonScope();
  bind(Entity).toSelf();
  bind(ObjectPool).toSelf();
  bind(World).toSelf().inSingletonScope();
});

export { Component, Entity, EntityManager, Matcher, System, World, containerModule };
